const rootPath="../../";
  const EndpointsController = require('./endpoints.controller');
  const PermissionMiddleware = require('../../common/middlewares/auth.permission.middleware');
  const ValidationMiddleware = require('../../common/middlewares/auth.validation.middleware');
  const config = require('../../common/config/env.config');
  const FormValidation = require('../../lib/validation');
  const ADMIN = config.permissionLevels.ADMIN;
  const USER = config.permissionLevels.APP_USER;
  const FREE = config.permissionLevels.NORMAL_USER;
  const formValidationRules=[
    {ctrl:'name',format:'text',required:true,max:50,min:2},
{ctrl:'path',format:'text',required:true,max:100,min:1},
{ctrl:'method',format:'',required:true},
{ctrl:'project',format:'text',required:true},
{ctrl:'headers',format:'array',required:true}
  ];
  exports.routesConfig = function (app) {
      app.post('/endpoints', [
        ValidationMiddleware.validJWTNeeded,
        FormValidation.formValidation(formValidationRules),
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        EndpointsController.insert
      ]);
      
      
      app.get('/endpoints', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          EndpointsController.list
      ]);
      app.get('/endpoints/all', [   //  Required to Fill UI Component like Dropdown ,List , can be disabled if not required
        ValidationMiddleware.validJWTNeeded,
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        EndpointsController.listAll
    ]);
    app.get('/endpoints/suggestions', [   //  Required to Fill UI Component like Auto Complete , can be disabled if not required
        ValidationMiddleware.validJWTNeeded,
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        EndpointsController.listSuggestions
    ]);
      app.get('/endpoints/:endpointsId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          EndpointsController.getById
      ]);
      app.patch('/endpoints/:endpointsId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          FormValidation.formValidation(formValidationRules,'UPDATE'),
          EndpointsController.patchById
      ]);
      app.delete('/endpoints/:endpointsId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(ADMIN),
          EndpointsController.removeById
      ]);


    
  };
  
    