const rootPath="../../";
  const ItemsController = require('./items.controller');
  const PermissionMiddleware = require('../../common/middlewares/auth.permission.middleware');
  const ValidationMiddleware = require('../../common/middlewares/auth.validation.middleware');
  const config = require('../../common/config/env.config');
  const FormValidation = require('../../lib/validation');
  const ADMIN = config.permissionLevels.ADMIN;
  const USER = config.permissionLevels.APP_USER;
  const FREE = config.permissionLevels.NORMAL_USER;
  const formValidationRules=[
    {ctrl:'itemName',format:'text',required:true,max:50,min:2},

{ctrl:'validation',format:'',required:false},
{ctrl:'itemType',format:'text',required:true},
{ctrl:'fileTypes',format:'array',required:false},
{ctrl:'endPoint',format:'',required:false},
{ctrl:'project',format:'text',required:true},
{ctrl:'value',format:'text',required:false}
  ];
  exports.routesConfig = function (app) {
      app.post('/items', [
        ValidationMiddleware.validJWTNeeded,
        FormValidation.formValidation(formValidationRules),
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        ItemsController.insert
      ]);
      
      
      app.get('/items', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          ItemsController.list
      ]);
      app.get('/items/all', [   //  Required to Fill UI Component like Dropdown ,List , can be disabled if not required
        ValidationMiddleware.validJWTNeeded,
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        ItemsController.listAll
    ]);
    app.get('/items/objects', [   //  Required to Fill UI Component like Dropdown ,List , can be disabled if not required
    ValidationMiddleware.validJWTNeeded,
    PermissionMiddleware.minimumPermissionLevelRequired(USER),
    ItemsController.listAllObject
]);
    app.get('/items/suggestions', [   //  Required to Fill UI Component like Auto Complete , can be disabled if not required
        ValidationMiddleware.validJWTNeeded,
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        ItemsController.listSuggestions
    ]);
      app.get('/items/:itemsId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          ItemsController.getById
      ]);
      app.patch('/items/:itemsId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          FormValidation.formValidation(formValidationRules,'UPDATE'),
          ItemsController.patchById
      ]);
      app.delete('/items/:itemsId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(ADMIN),
          ItemsController.removeById
      ]);
  };
  
    