const rootPath="../../";
  const LogingController = require('./loging.controller');
  const PermissionMiddleware = require('../../common/middlewares/auth.permission.middleware');
  const ValidationMiddleware = require('../../common/middlewares/auth.validation.middleware');
  const config = require('../../common/config/env.config');
  const FormValidation = require('../../lib/validation');
  const ADMIN = config.permissionLevels.ADMIN;
  const USER = config.permissionLevels.APP_USER;
  const FREE = config.permissionLevels.NORMAL_USER;
  const formValidationRules=[
    {ctrl:'endPoint',format:'text',required:true},
{ctrl:'project',format:'text',required:true},
{ctrl:'status',format:'text',required:true},
{ctrl:'sentObject',format:'',required:true},
{ctrl:'responseObj',format:'',required:true},
{ctrl:'ip',format:'text',required:false}
  ];
  exports.routesConfig = function (app) {
      app.post('/loging', [
        ValidationMiddleware.validJWTNeeded,
        FormValidation.formValidation(formValidationRules),
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        LogingController.insert
      ]);
      
      
      app.get('/loging', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          LogingController.list
      ]);
      app.get('/loging/all', [   //  Required to Fill UI Component like Dropdown ,List , can be disabled if not required
        ValidationMiddleware.validJWTNeeded,
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        LogingController.listAll
    ]);
    app.get('/loging/suggestions', [   //  Required to Fill UI Component like Auto Complete , can be disabled if not required
        ValidationMiddleware.validJWTNeeded,
        PermissionMiddleware.minimumPermissionLevelRequired(USER),
        LogingController.listSuggestions
    ]);
      app.get('/loging/:logingId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          LogingController.getById
      ]);
      app.patch('/loging/:logingId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(USER),
          FormValidation.formValidation(formValidationRules,'UPDATE'),
          LogingController.patchById
      ]);
      app.delete('/loging/:logingId', [
          ValidationMiddleware.validJWTNeeded,
          PermissionMiddleware.minimumPermissionLevelRequired(ADMIN),
          LogingController.removeById
      ]);
  };
  
    