const request = require('supertest')
const app = require('../server')
const userInfo = require('./userInfo')
describe('END-POINT endpoints', () => {
let newID="";
var auth = {accessToken:""};

it("Login", async () => {
const login = await request(app)
    .post('/auth')
    .send({
        email: userInfo.email,
        password: userInfo.password
    });
    if(login.statusCode==201){
        auth = login.body;
        console.log(auth.accessToken);
    }
    expect(login.statusCode).toEqual(201)
})      
it("POST '/endpoints/'", async () => {
    const res = await request(app)
    .post('/endpoints')
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "name":"nostrud",
"path":"nulla",
"method":"laborum",
"project":"eiusmod",
"headers":["value1","value1"]
    })
    expect(res.statusCode).toEqual(200)
    newID=res.statusCode==200?res.body["id"]:"";
    
})
it("POST '/endpoints/'", async () => {
    const res = await request(app)
    .post('/endpoints')
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "name":"veniam",
"path":"nisi",
"method":"elit",
"project":"cillum",
"headers":["value1","value1"]
    })
    expect(res.statusCode).toEqual(200)
    newID=res.statusCode==200?res.body["id"]:"";
    
})
it("GET '/endpoints/'", async () => {
    const res = await request(app)
    .get('/endpoints?name=nostrud&path=nulla&method=laborum&project=eiusmod&headers=value1')
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(200)
    
})

it("GET '/endpoints/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .get('/endpoints/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(200)
}else{
    console.log("**GET[ID] TEST HAS BEEN SKIPED")
}
    
})
it("PATCH '/endpoints/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .patch('/endpoints/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "name":"mollit",
"path":"amet",
"method":"utclf",
"project":"etclf",
"headers":["value1","value1"]
    })
    expect(res.statusCode).toEqual(204)
    }else{
        console.log("**PATCH TEST HAS BEEN SKIPED")
    }
})

it("DELETE '/endpoints/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .delete('/endpoints/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(204)
    }else{
        console.log("**DELETE TEST HAS BEEN SKIPED")
    }
})

})
  
