const request = require('supertest')
const app = require('../server')
const userInfo = require('./userInfo')
describe('END-POINT items', () => {
let newID="";
var auth = {accessToken:""};

it("Login", async () => {
const login = await request(app)
    .post('/auth')
    .send({
        email: userInfo.email,
        password: userInfo.password
    });
    if(login.statusCode==201){
        auth = login.body;
        console.log(auth.accessToken);
    }
    expect(login.statusCode).toEqual(201)
})      
it("POST '/items/'", async () => {
    const res = await request(app)
    .post('/items')
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "itemName":"incididunt",
"required":"false",
"validation":"utclf",
"itemType":"incididunt",
"fileTypes":["value1","value1"],
"endPoint":"Lorem",
"project":"sunt",
"value":"officia"
    })
    expect(res.statusCode).toEqual(200)
    newID=res.statusCode==200?res.body["id"]:"";
    
})
it("POST '/items/'", async () => {
    const res = await request(app)
    .post('/items')
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "itemName":"estclf",
"required":"false",
"validation":"nonclf",
"itemType":"cillum",
"fileTypes":["value1","value1"],
"endPoint":"culpa",
"project":"voluptate",
"value":"nulla"
    })
    expect(res.statusCode).toEqual(200)
    newID=res.statusCode==200?res.body["id"]:"";
    
})
it("GET '/items/'", async () => {
    const res = await request(app)
    .get('/items?itemName=incididunt&required=false&validation=utclf&itemType=incididunt&fileTypes=value1&endPoint=Lorem&project=sunt&value=officia')
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(200)
    
})

it("GET '/items/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .get('/items/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(200)
}else{
    console.log("**GET[ID] TEST HAS BEEN SKIPED")
}
    
})
it("PATCH '/items/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .patch('/items/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "itemName":"minim",
"required":"false",
"validation":"culpa",
"itemType":"sunt",
"fileTypes":["value1","value1"],
"endPoint":"nostrud",
"project":"adipisicing",
"value":"veniam"
    })
    expect(res.statusCode).toEqual(204)
    }else{
        console.log("**PATCH TEST HAS BEEN SKIPED")
    }
})

it("DELETE '/items/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .delete('/items/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(204)
    }else{
        console.log("**DELETE TEST HAS BEEN SKIPED")
    }
})

})
  
