const request = require('supertest')
const app = require('../server')
const userInfo = require('./userInfo')
describe('END-POINT loging', () => {
let newID="";
var auth = {accessToken:""};

it("Login", async () => {
const login = await request(app)
    .post('/auth')
    .send({
        email: userInfo.email,
        password: userInfo.password
    });
    if(login.statusCode==201){
        auth = login.body;
        console.log(auth.accessToken);
    }
    expect(login.statusCode).toEqual(201)
})      
it("POST '/loging/'", async () => {
    const res = await request(app)
    .post('/loging')
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "endPoint":"consectetur",
"project":"amet",
"status":"anim",
"sentObject":"Labore fugiat proident dolor in eu.",
"responseObj":"Officia ex cupidatat adipisicing enim id reprehenderit ut enim occaecat duis adipisicing.",
"ip":"amet"
    })
    expect(res.statusCode).toEqual(200)
    newID=res.statusCode==200?res.body["id"]:"";
    
})
it("POST '/loging/'", async () => {
    const res = await request(app)
    .post('/loging')
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "endPoint":"Lorem",
"project":"sint",
"status":"magna",
"sentObject":"Mollit culpa amet elit aliquip.",
"responseObj":"Excepteur do ullamco in.",
"ip":"cupidatat"
    })
    expect(res.statusCode).toEqual(200)
    newID=res.statusCode==200?res.body["id"]:"";
    
})
it("GET '/loging/'", async () => {
    const res = await request(app)
    .get('/loging?endPoint=consectetu&project=amet&status=anim&sentObject=Labore fug&responseObj=Officia ex&ip=amet')
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(200)
    
})

it("GET '/loging/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .get('/loging/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(200)
}else{
    console.log("**GET[ID] TEST HAS BEEN SKIPED")
}
    
})
it("PATCH '/loging/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .patch('/loging/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send({
        "endPoint":"dolor",
"project":"enim",
"status":"eaclf",
"sentObject":"Occaecat exercitation dolore veniam incididunt ad qui veniam aute consectetur laborum.",
"responseObj":"Deserunt proident laboris ut deserunt.",
"ip":"exclf"
    })
    expect(res.statusCode).toEqual(204)
    }else{
        console.log("**PATCH TEST HAS BEEN SKIPED")
    }
})

it("DELETE '/loging/"+newID+"'", async () => {
    if(newID!=""){
    const res = await request(app)
    .delete('/loging/'+newID)
    .auth(auth.accessToken, { type: 'bearer' })
    .send()
    expect(res.statusCode).toEqual(204)
    }else{
        console.log("**DELETE TEST HAS BEEN SKIPED")
    }
})

})
  
